part of masamune.flutter;

/// Base class for overriding and using providers.
///
/// You can create that provider by describing
/// how to create it in the constructor.
abstract class ProviderBase<T> extends AlwaysAliveProviderBase<T, T> {
  /// Base class for overriding and using providers.
  ///
  /// You can create that provider by describing
  /// how to create it in the constructor.
  ///
  /// [create]: Provider creation callback.
  ProviderBase(Create<T, ProviderReference> create) : super(create, null);

  @override
  ProviderOverride overrideWithProvider(RootProvider<Object, T> provider) {
    return ProviderOverride(provider, this);
  }

  @override
  _ProviderBaseState<T> createState() => _ProviderBaseState();
}

@sealed
class _ProviderBaseState<T> = ProviderStateBase<T, T>
    with _ProviderBaseStateMixin<T>;

mixin _ProviderBaseStateMixin<T> on ProviderStateBase<T, T> {
  @override
  void valueChanged({T previous}) {
    if (createdValue != exposedValue) {
      exposedValue = createdValue;
    }
  }
}
